#!/usr/bin/python

import urllib
import urllib2
import serial
import ConfigParser
import os.path
import commands

from time import sleep

def SendData(mac, port, line, url):
	values = {'Data': line,
			'Port': port,
			'Uid': mac }
	
	response = urllib2.urlopen(urllib2.Request(url+'sign',urllib.urlencode(values)))

def SendName(mac, line, url):
	values = { 'Uid': mac,
				'niceName': line }
	
	response = urllib2.urlopen(urllib2.Request(url+'name',urllib.urlencode(values)))

def getmac(iface):
    ifconfig = commands.getoutput("ifconfig "+iface+"| grep HWaddr | awk '{ print $5 }'").strip()
    if len(ifconfig) == 0:
            mac = 'Not found'
    else:
        mac = ifconfig[:17]
    return mac
	
def receive_line(ser):
	buffer = ''
	
	while True:
		buffer = buffer + ser.read(ser.inWaiting())
		sleep(0.5)
		
		if '\r' in buffer:
			lines = buffer.split('\r')
			return lines[-2]			

def download(mac, url):
	values = { 'DataBook_name': mac }
	response = urllib2.urlopen(urllib2.Request(url+'download?DataBook_name='+mac))
	return response.read()
	
			
def main():
	filename = 'ltrxpost.cfg'
	port = '/dev/ttyS1'
	baud = 9600
	url='http://ltrxpost.appspot.com/'
	
	parser = ConfigParser.SafeConfigParser()
	
	mac = getmac('wlan0')
	if mac == 'Not found':
		mac = getmac('eth0')
	
	if os.path.isfile(filename):
		parser.read([filename])	
		if parser.has_option('Config', 'Port'):
			port = parser.get('Config', 'Port')
		if parser.has_option('Config', 'baud'):
			baud = parser.get('Config', 'baud')
		if parser.has_option('Config', 'Device'):
			mac = parser.get('Config', 'Device')
		if parser.has_option('Config', 'URL'):
			url = parser.get('Config', 'URL')
		
	
	ser = serial.Serial(port, baud)
	
	ser.write('Welcome to the serial data http poster!\n\r')
	ser.write('Mac Address is: '+ mac +'\n\r')
	
	while True:
		line = receive_line(ser)
		print 'Received: %s' % line
	
		if line[:4] == 'send':
			SendData(mac, port, line[5:], url)
			ser.write('Sent: %s\n\r' % line[5:])
		elif line[:4] == 'exit':
			ser.write('Exiting...\n\r')
			break
		elif line[:4] == 'help':
			ser.write('Enter send xxx to post data to webapp\n\rEnter name to assign a name to your device\n\rEnter exit to exit program\n\r'+
				'Enter down to download waiting files from Management webpage\n\r')
		elif line[:4] == 'name':
			SendName(mac,line[5:], url)
			ser.write('Changing name to: %s\n\r' % line[5:])
		elif line[:4] == 'down':
			dat=download(mac,url)
			ser.write(dat)
			
	ser.close()

if __name__ == "__main__":
	main()


