#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <fcntl.h>
#include <string.h>

#define MAXLEN 255
#define EXTRA 5
#define MAXINPUT MAXLEN+EXTRA+2


void unencode(char *src, char *last, char *dest)
{
// for(; src != last; src++, dest++)
  for(; *src != '&'; src++, dest++)
   if(*src == '+')
     *dest = ' ';
   else if(*src == '%') {
     int code;
     if(sscanf(src+1, "%2x", &code) != 1) code = '?';
     *dest = code;
     src +=2; }     
   else
     *dest = *src;
 *dest = '\n';
 *++dest = '\0';
}

/* open_port1() open first serial port */

int
open_port1(void)
{
	int fd;

	fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NDELAY);
	if (fd == -1)
	{
		perror("open_port1: Unable to open /dev/ttyS1 - ");
	}
	else
	   fcntl(fd,F_SETFL,0);
	
	return (fd);
}


void main() {

char *lenstr, *ibufptr;
char input[MAXLEN], data[MAXLEN], ibuffer[MAXLEN];
long len;
int fd, n, nbytes;

    lenstr = getenv("CONTENT_LENGTH");

    /** Print the CGI response header, required for all HTML output. **/
    /** Note the extra \n, to send the blank line.                   **/
    printf("Content-type: text/html\n\n") ;
    printf("<html>\n<head><title>Response</title></head>\n");
    printf("<body>\n");

    if(lenstr==NULL || sscanf(lenstr, "%ld", &len)!=1 || len > MAXLEN)
	printf("<p>Error, make sure you enter at least 1 character and no more than 255 characters<p>");
    else  {
	fd = open_port1();
	fgets(input, len+1, stdin);
	unencode(input+EXTRA, input+len, data);
	n = write(fd, data, strlen(data));
	if (n < 0)
	   printf("<p>Error writing to serial port<p>");
	else
	{
	   sleep(3);
	   ibufptr = ibuffer;
	   while ( (nbytes=read(fd, ibufptr, ibuffer + sizeof(ibuffer) - ibufptr - 1 )) > 0 )
	   {
		ibufptr +=nbytes;
		if (ibufptr[-1] == '\n' || ibufptr[-1] == '\r')
		    break;
	   }
	   printf("<p>Response from device: %s\n", ibuffer);
	}
	close(fd);
    }
	
      
    printf("</body>\n") ;
    printf("</html>\n") ;

    return;
}
